%% Ej 1 TP 2  -  SyS 2017

%// Autor: SR
%// Distribucion conjunta Gaussiana correlacionada.

% Necesita en la misma carpeta las funciones 'plot_SR' y 'plot_SR_subplot'.

clear all; close all; clc;

%% c)

dt = 0.05; % Paso
[x,y] = meshgrid(-5:dt:5);
N = length(-5:dt:5);
% Cada fila de x es un vector -5:dt:5. x tiene N columnas.
% cada columna de y es un vector -5:dt:5. y tiene N filas.

sigma = 1;
rho = 0.8;

fXY = 1/(2*pi*sigma^2*sqrt(1-rho^2)).*exp(-(x.^2+y.^2-2.*x.*y.*rho)/(2*sigma^2*(1-rho^2)));
% Cada fila de fXY resulta de evaluar la expresion anterior en x e y como
% si fuese una region del plano donde se evalua una funcion de dos
% variables.

figure('units','normalized','outerposition',[0 0 1 1]) % Creo y maximizo figura.
mesh(x,y,fXY);grid on; % Grafico. Coloco los limites de los ejes. Grilla.
% view([0,0,1]);axis equal; % Miro desde arriba. Ejes iguales.
set(gca, 'FontSize', 20); % Tamao de letra para la leyenda y ejes.
xlabel('x','Interpreter','Latex'); % Nombro el eje x.
ylabel('y','Interpreter','Latex'); % Nombro el eje y.
zlabel('$f_{XY}(x,y)$','Interpreter','Latex'); % Nombro el eje y.
title(['$f_{XY}(x,y)$ de X e Y conjuntamente Gaussianas ' '$\rho$ = ' num2str(rho) '  $\sigma$ = ' num2str(sigma)],'Interpreter','Latex'); % Coloco ttulo para el grfico.

%%

% i) Para hallar las marginales debera integrarse una de las dos variables

fY = sum(fXY,2)*dt; % Verificar que la marginal de Y puede calcularse asi.
fX = sum(fXY,1)*dt; % Verificar que la marginal de X puede calcularse asi.

plot_SR([-5 5 0 0.5],'','','',20,y(:,1),fY);
hold on;
plot_SR_subplot([-5 5 0 0.5],'x, y','$f_X(x)$,$f_Y(y)$','fdp marginales',20,'r*',x(1,:),fX);
legend('f_Y(y)','f_X(y)')

% Notar que ambas son iguales y que ninguna depende de rho.

%%

% ii) Si rho = 0.99, -0.99 o 0. Verificar con la celda de mas arriba.

%%

% iii) Distribuciones condicionales

clear all;close all;clc

dt = 0.05; % Paso
[x,y] = meshgrid(-5:dt:5);

N = length(-5:dt:5);
sigma = 1;
rho = -0.5;

fXY = 1/(2*pi*sigma^2*sqrt(1-rho^2)).*exp(-(x.^2+y.^2-2.*x.*y.*rho)/(2*sigma^2*(1-rho^2)));
fY = sum(fXY,2)*dt; 
fX = sum(fXY,1)*dt; 

%% f_X/Y=y

for i=1:N
    fX_Y(:,i) = fXY(i,:)./(fY.'); % dado que y = cte
end

figure('units','normalized','outerposition',[0 0 1 1]) % Creo y maximizo figura.
mesh(x,y,fX_Y);grid on; % Grafico. Coloco los limites de los ejes. Grilla.
% view([0,0,10]);axis equal; % Miro desde arriba. Ejes iguales.
set(gca, 'FontSize', 20); % Tamao de letra para la leyenda y ejes.
xlabel('x','Interpreter','Latex'); % Nombro el eje x.
ylabel('y','Interpreter','Latex'); % Nombro el eje y.
zlabel('$f_{X/Y=y}(x/y)$','Interpreter','Latex'); % Nombro el eje y.
title(['$f_{X/Y=y}(x/y)$ de X e Y conjuntamente Gaussianas ' '$\rho$ = ' num2str(rho) '  $\sigma$ = ' num2str(sigma)],'Interpreter','Latex'); % Coloco ttulo para el grfico.

% Notar que a pesar de que el grafico arroja una superficie, la densidad
% condicional resulta una funcion de una variable. En el grafico se muestra
% el conjunto de curvas parametrizadas con y=cte, es decir, habria que ver
% la traza de esta superficie para un y particular. Esa seria la densidad
% condicional.

%% f_Y/X=x

for i=1:N
    fY_X(i,:) = fXY(:,i)./(fX.'); % dado que y = cte
end

figure('units','normalized','outerposition',[0 0 1 1]) % Creo y maximizo figura.
mesh(x,y,fY_X);grid on; % Grafico. Coloco los limites de los ejes. Grilla.
% view([0,0,10]);axis equal; % Miro desde arriba. Ejes iguales.
set(gca, 'FontSize', 20); % Tamao de letra para la leyenda y ejes.
xlabel('x','Interpreter','Latex'); % Nombro el eje x.
ylabel('y','Interpreter','Latex'); % Nombro el eje y.
zlabel('$f_{Y/X=x}(y/x)$','Interpreter','Latex'); % Nombro el eje y.
title(['$f_{Y/X=x}(y/x)$ de X e Y conjuntamente Gaussianas ' '$\rho$ = ' num2str(rho) '  $\sigma$ = ' num2str(sigma)],'Interpreter','Latex'); % Coloco ttulo para el grfico.

% Notar que a pesar de que el grafico arroja una superficie, la densidad
% condicional resulta una funcion de una variable. En el grafico se muestra
% el conjunto de curvas parametrizadas con x=cte, es decir, habria que ver
% la traza de esta superficie para un x particular. Esa seria la densidad
% condicional.

%% Intente realizar la simulacion de iv) usted solo. Luego compare abajo:

%%%%%%%%%%%%%%%%%%%% Complete usted el script %%%%%%%%%%%%%%%%%%%%







%%%%%%%%%%%%%%%%%%%% Complete usted el script %%%%%%%%%%%%%%%%%%%%





% iv) Z = X + Y;

clear all;close all;clc

M = 1e6;
dt = 0.05;
rho = 0.9;
sigma = 1;
u = randn(1,M);                     % u es N(0,1)
v = randn(1,M);                     % v es N(0,1)
X = sigma*u;                        % X es N(0,sigma^2)
Y = sigma*(rho*u+sqrt(1-rho^2)*v);  % Para correlacionar X con Y.
Z = X + Y;

[altZ,binZ] = hist(Z,50);                               % Histograma de Z.
figure('units','normalized','outerposition',[0 0 1 1])  % Creo y maximizo figura.
bar(binZ,altZ/M/(binZ(2)-binZ(1)));grid on;             % Grafico histograma normalizado. Grilla.
z = -10:dt:10;                                          % Valores de z.
% Densidad de prob. calculada en papel:
fZ = 1/(sqrt(2*pi*2*sigma^2*(1+rho))).*exp(-(z.^2/(4*sigma^2*(1+rho))));
hold on, plot(z, fZ,'r','LineWidth',3);                 % Grafico la densidad
axis([-8 8 0 max(fZ)*1.1]);                             % Limites de ejes
set(gca, 'FontSize', 16);                               % Tamao de letra para la leyenda y ejes.
xlabel('$z$','Interpreter','Latex');                    % Nombro el eje x.
ylabel('$f_{Z}$','Interpreter','Latex');                % Nombro el eje y.
title(['Comparacion $f_{Z}(z)$ de Z = X + Y , X, Y conjuntamente Gaussianas ' '$\rho$ = ' num2str(rho) '  $\sigma$ = ' num2str(sigma)],'Interpreter','Latex'); % Coloco ttulo para el grfico.

% Notar que sucede al hacer rho cercano a cero y rho cercano a 1. Piense en
% la expresion X+Y para explicar lo que sucede con la densidad de Z.
 