%% Ej 2 TP 2  -  SyS 2017

%// Autor: JS, SR
%// Realizaciones de algunos procesos continuos. Densidad del proceso.

% Necesita en la misma carpeta las funciones 'plot_SR'.

clear all; close all; clc;

%% Una realizacin de los proceso del ejercicio 2)a)

% a)

dt = 0.01;
t=0:dt:100;
A = randn;
Xa = A*ones(size(t));

plot_SR([t(1) t(end) -2 2],'t','$X_a(t)$',['Una realizacion de $X_a(t) = A = $ ' num2str(A)],20,t,Xa)

%%

% b)

clear all; close all; clc
dt = 0.01;
t=-10:dt:100;
A = randn;
Xb = (A+t).*ones(size(t));

plot_SR([0 10 0 10],'t','$X_b(t)$',['Una realizacion de $X_b(t) = A + t$, A = ' num2str(A)],20,t,Xb)

%%

% c)

clear all; close all; clc
dt = 0.01;
t=-10:dt:100;
A = randn;
Xc = A.*exp(-t);

plot_SR([0 10 -abs(A) abs(A)],'t','$X_c(t)$','Una realizacion de $X_c(t) = Ae^{-t}$',20,t,Xc)

%% Muchas realizaciones juntas del proceso del ej. 2)a)II.

clear all; close all; clc
dt = 0.01;
t=0:dt:10;

realizaciones = 5000;
Xb2 = zeros(length(t),realizaciones); % Creo una matriz

for i=1:realizaciones
    Xb2(:,i) = randn + t;             % Cada columna es una realizacion.
                                      % Cada fila representa a los valores
                                      % que toma una variable aleatoria
                                      % N(t,1).
end

plot_SR([0 10 -5 15],'t','$X_b(t)$','Muchas realizaciones de $X_b(t) = A + t$',20,t,Xb2)

%% El histograma de las realizaciones anteriores para un t_0 particular

close all;

t0 = 1;                                                 % t0 > 0 para este codigo.
Xb_t0 = Xb2(t0/dt,:);                                   % evaluo la fila t0/dt de la matrix Xb2
M = length(Xb_t0);

[altXb,binXb] = hist(Xb_t0,20);                         % Histograma de Xb(t0).
figure('units','normalized','outerposition',[0 0 1 1])  % Creo y maximizo figura.
bar(binXb,altXb/M/(binXb(2)-binXb(1)));grid on;         % Grafico histograma normalizado. Grilla.
dx = 0.01;                                              % Paso 
x = -5:dx:5;                                            % Valores de x.
fX = 1/(sqrt(2*pi)).*exp(-((x-t0).^2)/2);               % Densidad de prob. Normal (t0,1):
hold on, plot(x, fX,'r','LineWidth',3);                 % Grafico la densidad
axis([-5 5 0 max(fX)*1.1]);                             % Limites de ejes
set(gca, 'FontSize', 16);                               % Tamao de letra para la leyenda y ejes.
xlabel('$x$','Interpreter','Latex');                    % Nombro el eje x.
ylabel('$f_{X}$','Interpreter','Latex');                % Nombro el eje y.
title(['Comparacion $f_{X}(x):N(0,1)$  y el histograma de $X_b(t_0 = $' num2str(t0) '$)$'],'Interpreter','Latex'); % Coloco ttulo para el grfico.

%% Grafico de densidades segun cada t

t0=-5:.1:10;
x = 0:.5:5;                                                 % Valores de x.
[TT,XX]=meshgrid(t0,x);
fX = 1/(sqrt(2*pi)).*exp(-((XX-TT).^2)/2);                  % Densidad de prob. Normal (t0,1):

figure('units','normalized','outerposition',[0 0 1 1])      % Creo y maximizo figura.
waterfall(TT,XX,fX); shading('flat'); axis ij
xlabel('$x$','Interpreter','Latex','Fontsize',15);          % Nombro el eje x.
ylabel('$t$','Interpreter','Latex','Fontsize',15);          % Nombro el eje y.
zlabel('$f_X(x;t)$','Interpreter','Latex','Fontsize',15);   % Nombro el eje y.