%% Ej 2 TP 2  -  SyS 2017

%// Autor: JS, SR
%// Realizaciones del proceso discreo 'random walk'. Varianza.

% % % Necesita en la misma carpeta las funciones 'plot_SR' y 'plot_SR_subplot'.

clear all; close all; clc;

%% Una realizacin del proceso de caminata aleatoria del ej. 2)d)

close all;

N = 1e3;            % 
a = randn(1,N);     % Creo VA gaussianas N(0,1)
n = 1:N+1;          % Tengo N+1 muestras ya que W inicializa en 0
S = (a>0) - (a<0);  % Para que S[n] sea -1 o 1 con igual probabilidad.
W = [0 cumsum(S)];  % Armo W acumulando. Inicializo en 0.

plot_SR([n(1) n(end) -abs(min(W)) abs(max(W))],'n','$W[n]$','Una realizacion de $W[n]$',20,n,W)


%% Muchas realizaciones juntas del proceso del ej. 2)d)

clear all;close all;

N = 1e3;
n = 1:N+1;
realizaciones = 500;

W2 = zeros(N+1,realizaciones); % Inicializo W2 en 0. Recomendable antes de hacer un for.

for i=1:realizaciones
    a = randn(1,N);
    S = (a>0) - (a<0);
    W2(:,i) = [0 cumsum(S)]; % Cada columna de W2 es una realizacion
end

plot_SR([n(1) n(end) -abs(min(min(W2))) abs(max(max(W2)))],'n','$W[n]$',[num2str(realizaciones) ' realizaciones de $W[n]$'],20,n,W2)

%% Una estimacin de la varianza del proceso de caminata aleatoria utilizando las realizaciones anteriores

varianza = var(W2,[],2); % Buscar que hace var() en matlab.

plot_SR([n(1) n(end) 0 N+1],'n','$Var[n]$','',20,n,varianza)
hold on;
plot_SR_subplot([n(1) n(end) 0 N+1],'n','$Var[n]$','Comparacion de varianza de $W[n]$ estimada vs calculada',20,'g',n,n+1)
legend('Var(W[n]) estimada','Var(W[n]) calculada','Location','SouthEast')

% Claramente a mayor numero de realizaciones y mas largo el vector de
% muestras, mas parecida es la estimacion con el calculo analitico.

%% Muchas realizaciones juntas del proceso del ej. 2)d) y regla del +-3 sigma.

clear all;close all;

N = 1e3;
n = 1:N+1;
realizaciones = 1000;

W2 = zeros(N+1,realizaciones); % Inicializo W2 en 0. Recomendable antes de hacer un for.

for i=1:realizaciones
    a = randn(1,N);
    S = (a>0) - (a<0);
    W2(:,i) = [0 cumsum(S)]; % Cada columna de W2 es una realizacion
end

plot_SR([n(1) n(end) -abs(min(min(W2))) abs(max(max(W2)))],'','','',20,n,W2)
hold on
plot_SR_subplot([n(1) n(end) -abs(min(min(W2))) abs(max(max(W2)))],'','','',20,'b.',n,3*sqrt(n+1))
hold on
plot_SR_subplot([n(1) n(end) -abs(min(min(W2))) abs(max(max(W2)))],'n','',[num2str(realizaciones) ' Realizaciones y cota de $\pm 3 \sigma = \pm 3 \sqrt{n+1}$'],20,'b.',n,-3*sqrt(n+1))

% Notar que la regla de +- 3 veces la desviacion estandar otorga un
% resultado coherente con las realizaciones debido a que W[n] es binomial,
% y para n grande, la binomial es practicamente la normal. Por lo tanto,
% suponer que el 99% de las realizaciones caen en +-3 sigma, tiene sentido.
