%% Ej 5 TP 2  -  SyS 2017

%// Autor: JS, SR
%// Sinusoide aleatoria. Realizaciones, esperanza y autocorrelacion.

% Necesita en la misma carpeta las funciones 'plot_SR', % EstimacionRxxESA'
% y 'plot_SR_subplot'.

clear all; close all; clc;

%% a) w0 y A ctes. Theta VA uniforme en [-pi, pi]

clear all; close all; clc;

% Dibujo algunas realizaciones a) y la media.

N = 1e3;
f0 = 1;
w0 = 2*pi*f0;
A = 10;
theta1 = (rand(1,N)-0.5)*2*pi;

dt = 0.01;
t = -1:dt:1;

for i=1:N
    X1(i,:) = A*cos(w0*t+theta1(1,i));
end

est_media_a = sum(X1,1)*1/N;

plot_SR([t(1) t(end) -10 10],'','','',20,t,X1)
hold on
plot_SR_subplot([t(1) t(end) -10 10],'','','',20,'r*',t,est_media_a)
hold on
plot_SR_subplot([t(1) t(end) -10 10],'$t$','','Realizaciones de $X(t) = A cos(\omega_0 t + \theta)$ con $\theta$ distribuido $U[-\pi,\pi]$',20,'y',t,zeros(1,length(t)));

%% Estimacin de la Rxx a)

largo_secuencia = length(X1(1,:));
m_max=100;

Rx1 = EstimacionRxxESA(X1,largo_secuencia,m_max);

m = -m_max:m_max;
tau = m*dt;

plot_SR([tau(1) tau(end) -51 51],'$\tau$','','Aproximacion $R_{XX}(\tau)$ del proceso a)',20,tau,Rx1)

%% Intente realizar la simulaciones de los que siguen. Luego compare abajo:

%%%%%%%%%%%%%%%%%%%% Complete usted el script %%%%%%%%%%%%%%%%%%%%







%%%%%%%%%%%%%%%%%%%% Complete usted el script %%%%%%%%%%%%%%%%%%%%

%% b) w0 y A ctes. Theta VA uniforme en [-pi/2, pi/2]

clear all;close all;

% Dibujo algunas realizaciones a) y la media.

N = 700;
f0 = 1;
w0 = 2*pi*f0;
A = 4;
theta2 = (rand(1,N)-0.5)*pi;

dt = 0.01;
t = -1:dt:1;

for i=1:N
    X2(i,:) = A*cos(w0*t+theta2(1,i));
end

est_media_b = sum(X2,1)*1/N;

plot_SR([t(1) t(end) -5 5],'','','',20,t,X2)
hold on
plot_SR_subplot([t(1) t(end) -5 5],'$t$','','Realizaciones de $X(t) = A cos(\omega_0 t + \theta)$ con $\theta$ distribuido $U[-\pi/2,\pi/2]$',20,'r*',t,est_media_b)
hold on
plot_SR_subplot([t(1) t(end) -5 5],'$t$','','Realizaciones de $X(t) = A cos(\omega_0 t + \theta)$ con $\theta$ distribuido $U[-\pi/2,\pi/2]$',20,'y',t,2*A/pi*cos(w0.*t));

%% Estimacin de la Rxx b)

largo_secuencia = length(X2(1,:));
m_max=100;

Rx2 = EstimacionRxxESA(X2,largo_secuencia,m_max);

m = -m_max:m_max;
tau = m*dt;

plot_SR([tau(1) tau(end) -9 9],'$\tau$','','Aproximacion $R_{XX}(\tau)$ del proceso b)',20,tau,Rx2)

%% e) A cte. Theta VA uniforme en [-pi, pi], wo VA uniforme en [-Bpi, Bpi] indp. de theta.

clear all;close all;

% Dibujo algunas realizaciones a) y la media.

N = 1000;
B = 3;
w0 = (rand(1,N)-0.5)*B*2*pi;
A = 1;
theta5 = (rand(1,N)-0.5)*2*pi;

dt = 0.01;
t = -2:dt:2;

for i=1:N
    X5(i,:) = A*cos(w0(1,i)*t+theta5(1,i));     
end

est_media_e = sum(X5,1)*1/N;

plot_SR([t(1) t(end) -1.1 1.1],'','','',20,t,X5)
hold on
plot_SR_subplot([t(1) t(end) -1.1 1.1],'','','',20,'r*',t,est_media_e)
hold on
plot_SR_subplot([t(1) t(end) -1.1 1.1],'$t$','','Realizaciones de $X(t) = A cos(\omega_0 t + \theta)$ con $\theta$ $U[-\pi,\pi]$ y $\omega_0$ $U[-B\pi,B\pi]$',20,'y',t,zeros(1,length(t)));

%% Estimacin de la Rxx e)

largo_secuencia = length(X5(1,:));
m_max=100;

Rx5 = EstimacionRxxESA(X5,largo_secuencia,m_max);

m = -m_max:m_max;
tau = m*dt;

plot_SR([tau(1) tau(end) -0.2 0.6],'','','',20,tau,Rx5)
hold on
plot_SR_subplot([tau(1) tau(end) -0.2 0.6],'$\tau$','','Aproximacion $R_{XX}(\tau)$ del proceso e)',20,'r*',tau,A^2/2.*sinc(B.*tau))

